/*
  Module PIRs
  part of Arduino Mega Server project
*/

#ifdef PIRS_FEATURE

//#define EVENTS_PIRS

// Pins
#define PIR1_PIN 8 // CON1 / NRF24
#define PIR2_PIN 9 // CON2 / NRF24

// states
int pir1state = LOW; int pir1 = 0;
int pir2state = LOW; int pir2 = 0;

// init
void pirsInit() {
  pinMode(PIR1_PIN, INPUT);
  pinMode(PIR2_PIN, INPUT);
  modulePirs = MODULE_ENABLE;
  started("PIR");
}

void detect(char s[]) {
  #ifdef EVENTS_PIRS
    timeStamp();
    Serial.print("Detect motion ");
    Serial.println(s);
  #endif
}

void endMmotion(char s[]) {
  #ifdef EVENTS_PIRS
    timeStamp();
    Serial.print("End motion ");
    Serial.println(s);
  #endif
}

void pirsWorks() {
  // pir1
  pir1 = digitalRead(PIR1_PIN);
  if (pir1 == HIGH) { 
    if (pir1state == LOW) {
      detect("PIR 1");
      pir1state = HIGH;
      #ifdef MAJORDOMO_FEATURE
        sendRequestM("pirSTD", 1);
      #endif
      #ifdef LEDS_FEATURE
        if (modeLED == LED_PIR) {
          //green(led1, bright);
        }
      #endif
    }
  } else {
    if (pir1state == HIGH){
      endMmotion("PIR 1");
      pir1state = LOW;
      #ifdef MAJORDOMO_FEATURE
        sendRequestM("pirSTD", 0);
      #endif
      #ifdef LEDS_FEATURE
        //black(led1);
      #endif
    }
  }
    
  // pir2
  pir2 = digitalRead(PIR2_PIN);
  if (pir2 == HIGH) { 
    if (pir2state == LOW) {
      detect("PIR 2");
      pir2state = HIGH;
      #ifdef MAJORDOMO_FEATURE
        sendRequestM("pirHAL", 1);
      #endif
      #ifdef LEDS_FEATURE
        if (modeLED == LED_PIR) {
          //blue(led1, bright);
        }
      #endif
    }
  } else {
    if (pir2state == HIGH){
      endMmotion("PIR 2");
      pir2state = LOW;
      #ifdef MAJORDOMO_FEATURE
        sendRequestM("pirHAL", 0);
      #endif
      #ifdef LEDS_FEATURE
        //black(led1);
      #endif
    }
  }
} // pirsWorks()

#endif // PIRS_FEATURE
