/*
  Module Documentation
  part of Arduino Mega Server project
*/

/* 
Analog pins
===========
 A5 - PM i5  channel
 A4 - PM i4  channel
 A3 - PM i3  channel
 A2 - PM i2  channel
 A1 - PM i1  channel
 A0 - PM U

GPIO
====

SCL -
SDA -
D13 - Ethernet        (SCK)
D12 - Ethernet        (MISO)
D11 - Ethernet  [PWM] (MOSI)
D10 - Ethernet  [PWM] (SS for Ethernet controller)
D9 - PIR2/CON2/NRF24 (CSN)
D8 - PIR1/CON1/NRF24 (CE)
D7 - ledG
D6 - ledR
D5 - ledB
D4 - Ethernet (SS for SD card)
D3 - [PWM] - Key
D2 - 1-Wire
D1 - [TX]
D0 - [RX]


nRF24 packet structure
======================
01234567890123456789012345678901
.........ppppppppddddddddddddddd
        9       8             15

 buff[0] - packet type
 buff[1] - command
 buff[2] - address
 buff[3] - destination address
 buff[4] - required answer
 buff[5] - packet number
 buff[6] - reserve
 buff[7] - reserve
 buff[8] - reserve
 buff[9] - password 1
buff[10] - password 2
buff[11] - password 3
buff[12] - password 4
buff[13] - password 5
buff[14] - password 6
buff[15] - password 7
buff[16] - password 8
buff[17] - data 1
buff[18] - data 2
buff[19] - data 3
buff[20] - data 4
buff[21] - data 5
buff[22] - data 6
buff[23] - data 7
buff[24] - data 8
buff[25] - data 9
buff[26] - data 10
buff[27] - data 11
buff[28] - data 12
buff[29] - data 13
buff[30] - data 14
buff[31] - data 15

nRF24 packets type
=================
0 - empty
1 - command
2 - request
3 - data
4 - alarm
5 - answer
6 - echo

*/
