/*
  Module ID
  part of Arduino Mega Server project
*/

// Hardware
#define MAX_ANALOG_PORTS  5
#define MAX_DIGITAL_PORTS 14

#define MIN_ID_CHAR 48
#define MAX_ID_CHAR 122
#define MAX_CODE    34
byte code[] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G','H','J','K','L','M','N','P','Q','R','S','T','U','V','W','X','Y','Z'};

// random init

void randomInit() {
  long magic = 0;
  getSeed();
  for (int i = 0; i < random(9, 200); i++) {
    randomSeed(getSeed());
    for (int j = 0; j < random(9, 9999) + 1; j++) {
      magic += random(9, 9999);
    }
  }
  randomSeed(magic);
}

int getSeed() {
  int seed = 0;
  for (byte i = 0; i < MAX_ANALOG_PORTS;  i++) {seed +=  analogRead(i);}
  for (byte i = 0; i < MAX_DIGITAL_PORTS; i++) {seed += digitalRead(i);} 
  return seed;
}

bool validChar(byte b) {
  for (byte i = 0; i < MAX_CODE; i++) {
    if (code[i] == b) {
      return true;
    }
  }
  return false;
}

void generateId() {
  randomInit();
  for (byte i = 0; i < MAX_ID_DIGS; i++) {
    //buffId[i] = random(MIN_ID_CHAR, MAX_ID_CHAR);
    buffId[i] = code[random(0, MAX_CODE)];
  }
}

String stringId() {
  String s = "";
  for (byte i = 0; i < MAX_ID_DIGS; i++) {
    s += char(buffId[i]);
  }
  return s;
}

void printId(String prefix, String suffix) {
  Serial.print(prefix);
  for (byte i = 0; i < MAX_ID_DIGS; i++) {
    Serial.print(char(buffId[i]));
  }
  Serial.print(suffix);
}

